// Kadar Qian
// Professor Ge Wang
// Music 256A | CS 476A
// Narrative

// Based on Chopin's Barcarolle!

60 => float bpm;
minute / bpm => dur qtr;
qtr / 2 => dur dbl;
qtr / 3 => dur trp;
qtr / 6 => dur sxp;

Rhodey bassInstr => NRev r => dac;
Mandolin melodyInstr => r;
.3 => r.mix;

int bassIntro[];
dur bassIntroDur[];
[30,37,44, 42,44, 46,37, 30,37,44, 42,44, 46,49] @=> bassIntro;
[trp,trp,trp, sxp,sxp, trp,trp, trp,trp,trp, sxp,sxp, trp,trp] @=> bassIntroDur;

int melodyIntro[];
int melodyDynamics[];
dur melodyIntroDur[];
[100000, 73, 72,73, 75,73,70, 78,70,75, 73,66,71, 70] @=> melodyIntro;
[qtr, (qtr+trp), trp,trp, trp,trp,trp, trp,trp,trp, trp,trp,trp, (qtr*2)] @=> melodyIntroDur;

int bassPhrase2[];
dur bassPhrase2Dur[];
[30,42,49, 47,49, 51,42, 30,42,49, 47,49, 51,54, 30,42,49, 47,49, 51,42, 30,37,44, 42,44, 46, 29] @=> bassPhrase2;
[trp,trp,trp, sxp,sxp, trp,trp, trp,trp,trp, sxp,sxp, trp,trp, trp,trp,trp, sxp,sxp, trp,trp, trp,trp,trp, sxp,sxp, trp,trp, trp,trp,trp, sxp,sxp, trp,trp, trp,trp,trp, sxp,sxp, trp,trp, trp,trp,trp, sxp,sxp, trp,trp, trp,trp,trp, sxp,sxp, trp,trp] @=> bassPhrase2Dur;

int melodyPhrase2[];
dur melodyPhrase2Dur[];
[71, 78, 77,78, 80,78,75, 83,75,77, 78,71,72, 75,73,61, 70] @=> melodyPhrase2;
[qtr, (qtr+trp), trp,trp, trp,trp,trp, trp,trp,trp ,trp,trp,trp ,trp,trp,trp, qtr] @=> melodyPhrase2Dur;

for (int i; i < 2; i++) {
    playBass();
    playBassPhrase2();
}
trip();

play(30, .2, 2::second, bassInstr);

fun void trip() {
    spork ~ playRandomHigh();
    
    for (int times; times < 8; times++) {
        for (int i; i < bassIntro.size(); i++) {
            play(bassIntro[i], .6, bassIntroDur[i], bassInstr);
        }
    }
}

fun void playRandomHigh() {
    TriOsc high => dac;
    [0, 2, 4, 5, 6, 7, 9, 11, 12] @=> int scale[];
    
    for (int i; i < 50; i++) {
        scale[Std.rand2(0, scale.size() - 1)] => float randomHigh;
        Std.mtof(78 + (Std.rand2(-1,1)*12 + randomHigh) ) => high.freq;
        0 => high.phase;
        400::ms => now;
    }
}

fun void playBass() {
    for (int i; i < 4; i++) {
        if (i == 2) {
            spork ~ playMelody();
        }
        for (int i; i < bassIntro.size(); i++) {
            play(bassIntro[i], .2, bassIntroDur[i], bassInstr);
        }
    }
}

fun void playBassPhrase2() {
    spork ~ playMelodyPhrase2();
    for (int i; i < bassPhrase2.size(); i++) {
        play(bassPhrase2[i], 0.25, bassPhrase2Dur[i], bassInstr);
    }
}

fun void playMelody() {
    for (int i; i < melodyIntro.size(); i++) {
        play(melodyIntro[i], .25, melodyIntroDur[i], melodyInstr);
    }
}

fun void playMelodyPhrase2() {
    for (int i; i < melodyPhrase2.size(); i++) {
        play(melodyPhrase2[i], .25, melodyPhrase2Dur[i], melodyInstr);
    }
}

// function to play a note
fun void play( float pitch, float velocity, dur T, StkInstrument instr)
{
    // set pitch
    pitch => Std.mtof => instr.freq;
    // play!
    velocity => instr.noteOn;
    // let time pass
    T => now;
}
